<div align="center">
<h1>Solid Testing Library</h1>

<p>Simple and complete Solid DOM testing utilities that encourage good testing
practices.</p>

> Inspired completely by [preact-testing-library](https://github.com/testing-library/preact-testing-library)

[![Build Status](https://img.shields.io/travis/com/ryansolid/solid-testing-library.svg?style=flat)](https://travis-ci.com/ryansolid/solid-testing-library)
[![Coverage Status](https://img.shields.io/coveralls/github/ryansolid/solid-testing-library.svg?style=flat)](https://coveralls.io/github/ryansolid/solid-testing-library?branch=main)
[![NPM Version](https://img.shields.io/npm/v/solid-testing-library.svg?style=flat)](https://www.npmjs.com/package/solid-testing-library)
[![](https://img.shields.io/npm/dm/solid-testing-library.svg?style=flat)](https://www.npmjs.com/package/solid-testing-library)
[![Discord](https://img.shields.io/discord/722131463138705510)](https://discord.com/invite/solidjs)

</div>

<hr />

## Table of Contents

- [The Problem](#the-problem)
- [The Solution](#the-solution)
- [Installation](#installation)
- [Docs](#docs)

## The Problem

You want to write tests for your Solid components so that they avoid including implementation
details, and are maintainable in the long run.

## The Solution

The Solid Testing Library is a very lightweight solution for testing Solid components. Its primary guiding principle is:

> [The more your tests resemble the way your software is used, the more confidence they can give you.](https://twitter.com/kentcdodds/status/977018512689455106)

## Installation

This module is distributed via npm which is bundled with node and should be installed
as one of your project's `devDependencies`:

```
npm install --save-dev solid-testing-library
```

💡 You may also be interested in installing `@testing-library/jest-dom` so you can use
[the custom jest matchers](https://github.com/testing-library/jest-dom).

## Docs

TODO
<!-- See the [docs](https://testing-library.com/docs/preact-testing-library/intro) over at the Testing
Library website. -->
